2021-02-01 V1.9.9
   Upgrading Versions of All Systems
     64 bit Windows
     32-bit Windows
     64-bit Linux
     32-bit Linux

2021-01-29 V1.9.8
  Added proprerties "MaxFiles", "MaxShowImageSize", "MaxKoSize" of the "Attachment" component

2021-01-29 V1.9.7
   Publication in Linux 64 bits
   Revision and correction ....datasetlocate API

2021-01-28 V1.9.6
   Editing grid display revision: securing parameters
   Addition to the forms of a new component: "Attachments"
   Various small improvements
   Various bugs fixed

2021-01-23 V1.9.5
   Correction date.lua library, publication of the date class
   DateTimePicker component:
     - Added luadate property
     - Taking into account of the "Delete ..." keys to set the date to null
   ComboBox revision:
     - Correction of some anarchic operations
     - Added "ThemedStyle" property
     - Acceptance of -1 (all columns) in the "ColumnsDisplayIndex" property
   Revision of query editor:
     - Fixed messy operation when modifying a visual query
     - Treatment of aliases containing spaces
     - Improved display of the result in editing
   Revision of the Export form:
     - Table / view differentiation
     - Logical revision of types
     - Bug fix in sqlite export (label / name)
   Various bugs fixed

2021-01-18 V1.9.4
   Add nsbase.dialog.picklist API
   Added "warning" option on nsbase.dialog.input API
   Addition of new functions in the LUA nsbaseutils library:
   - applyConditionalFormat
   - evalExpr
   - eval
   Transferring the getFormName function from nsbaselists to nsbaseutils
   Added the possibility to put color values in string for the setProperty API

2021-01-17 V1.9.3
   Improvement of the typing propagation via the SQL queryer, in particular on the monetary type
   Adding access to data typing in the SQL query editor
   Modifying the conditional rules of the DBGrid component to account for the direct type of data
   Fixed onclick action (code regression) on DBGrid and RadioGroup components
   Correction of the "DBgrids" filter for the names of fields containing spaces
   Taking into account of the "disable" state of the buttons whose property "color" is assigned
   Add "Margin" property on Button

2021-01-03 V1.9.2
   Significant improvement of the form creation wizard:
      - Automatic choice of the type of component according to its type: real, monetary, relation ...
      - Auto creation of necessary requests
   Generalization of the formatting and symbol cloud for currency and decimal types
      - Added symbol / currency and decimal formatting parameters in the project property page
      - Added DisplayCurrency, DisplayFormat, DisplayNumber properties in
           the TextEdit and MskEdit components
      - Revision of SQL requester, datagrid ...
   Add scroll bars for displaying forms in execution
   Adding import / export of forms and reports
   Various bugs fixed

2020-11-12 V1.9.1
   Correction of the typing of data from the nsbase.window.getProperty API
     the LUA type of the data is now of the type of the property and not of the value
   Minimalist zoom addition in the edition of reports
   Various bugs fixed

2020-11-12 V1.9.0
  This update includes 2 areas of progress:
     - The switch to multipage of the page backgrounds of the reports
     - A global technical update
  Complete review of the edition, generation and display of reports
  Automatic report migration
  Update LUA 5.3 to LUA 5.4
  SQLite 3.33.0 32-bit and 64-bit Windows update
  32-bit and 64-bit SumatraPDF 3.2 Windows update
  Rename libmariadb.dll files to libmariadb-32.dll and libmariadb-64.dll
  Renaming the sqlite3.dll and sqlite3-32.dll files
  Improved error messages from SQLite
  Fixed non-visual SQL query indentation
  Fixed DBTreeView component errors
  Fixed some combobox behaviors
  Fixed errors in the process of using relationship type fields
  Compression executables (exe and dll) by UPX
  Addition of "bitmap" format (glyph example of buttons) in the get / setProperty APIs
  Various small improvements
  Correction of diving bugs

2020-10-30 V1.8.0
  Adding mouse actions with recovery
     information (x, y, button, shift) on most components
    - ActionOnMouseMove
    - ActionOnMouseEnter
    - ActionOnMouseLeave
    - ActionOnMouseUp
    - ActionOnMouseDown
  Added import of NsDBAppCreator applications
  Add control and utility for creating missing physical tables
  API addition on database objects (tables, views, shapes, etc.)
    - nsbase.application.getObjects
  Revised LUA mode of the nsbase.window.getControls API
  Typing of data from the nsbase.window.getProperty API
  Addition of the CPLib.lua library for managing French postal codes
  Addition of the nsbaselist.lua library: list management utilities
  Review of the ergonomics of the list assistant
  Revision of the list wizard code generation:
    - the generated code is different and optimized by the use of LUA libraries
    - the old generated code can still be used
  Multilingual transition of the "New project from a template" dialog box
  Republication of models (autolists)
    - Video library
    -- Bill
  Publication of new models
    -- Library
    - Automotive
  Publication examples
     - Postal code
  Nsbaseutils library update
  Improved LUA response times
  Various small improvements
  Various bugs fixed

2020-09-24 V1.7.3a
  Fixed component search path in APIs

2020-09-16 V1.7.3
   Correction Bug developed in V1.7.1 nbase.window.getproperty (....
   Easier control APIs Dataset.Close
   Fixed code checker
     'Illegal API' error
     consideration of comments

2020-08-26 V1.7.2
   Fixed bug displaying object explorer in LUA editor
   Publishing properties
     ColumnsIndent,
     ColumnsMargin,
     ColumnsSeparator,
     ColumnsLinkIndex for Listbox and Combobox components
   Add APIs
     createControl,
     deleteControl,
     getControls

2020-08-25 V1.7.1
   Compiled under LAZARUS 2.0.10 (Windows 32 bits and 64 bits)
   Addition of error checks in Dataset APIS
   Disable Windows theme if color <> clDefault for "buttons"
   Fixed value type return on getFieldname API
   Correction of object copy function on databases with file
     separate data

2020-08-14 V1.7.0
   Add "Style sheets" object see tab / create
   Refitting group search in the script editor
   Add function go to line no.
   Add declaration search function in the script editor
   Add functionality for duplicating reports and forms
   Add table dump functionality
   Correction of GET / SET context menu in report edition
   Correction ActionOnKeyPressed
   Various improvements
   Various bugs fixed

2020-06-17 V1.6.7
   Add ActionOnLoad in reports and forms
   Add ActionOnOpen to forms
   Add ActiveControl runtime property to forms
   Add ActiveCol and ActiveRow runtime properties to DBGrid
   Correction filters on date type of tables, views ...
   Correction Get / Set in tree property of the LUA editor
   Correction visual requester on conditions
   Correction of the 2nd field of the ConditionalFormatting property
   BevelInner fix for HtmlMemo component
   Correction copy / paste of components in the visual editor
   Improved handling of repetitive errors in standalone mode (executable)
   Miscellaneous improvements
   Various bugs correction

2020-05-10 V1.6.6
   Improved control of the LUA code
   Improved formatting of LUA code
   Improved conditional display of DBGrids
   Miscellaneous improvements
   Various bugs correction

2020-05-03 V1.6.5
   Improved LUA error handling
   Add "Verify" button (LUA code verification) in the LUA script editor
   Miscellaneous improvements
   Various bug fixes

2020-04-22 V1.6.4
   Compiled under LAZARUS 2.0.6 (64 bits)
   Improved display of LUA variables: memo of nodes
   Correction of LUA code trainer: takes into account comments
   Add code marker icons in LUA editor
   Miscellaneous improvements
   Various bug fixes

2020-03-24 V1.6.3
   Add function tree in the LUA script editor
   Add "Format" button (code formatting) in the LUA script editor
   Add button "Save all" (shift-ctrl-s)
   Add change indicator (*) in the names of the tabs
   Miscellaneous improvements
   Various bug fixes

2020-03-08 V1.6.2
  Add APIs
    self.refresh ()
    nsbase.getInfo ()
  Fixed abandonment when deleting a DateTimePicker component
  Sorting lists of data sources, field names
  Change "Lines" property of the "memoHtml" component to "Html"
  Add mini html editor to edit the "Html" property of the "memoHTml" component
  Updating language files
  Miscellaneous improvements
  Various bug fixes

2020-02-16 V1.6.1
   Add component "memoHTML", which can be included as an image in reports
     see direct mail demo in the "Contacts.nsb" database
   Add action "ActionOnUnload" in reports
   Add "Zoom" property in reports
   Addition of the "BuildPicture" property in the chart component.
     Please note, you will need to activate it before recovering the graphic image
   Correction Report: missing a recording in the grids
     and exception when deleting the grid
   Miscellaneous improvements
   Various bug fixes

2020-02-08 V1.6.0
  DBGrid component review
    Warning !!!
    you may need to activate the dgEditing option
  Multicolumn addition on combobox and listbox
  Revision assistant creation of components type list
  Integration of the formatting of the columns of a dbgrid
  Addition of display options (full screen)
  Add comment / uncomment in LUA editor
  Add classification of objects in the explorer
  Add API: nbase.application.getSQLFromDatasource
  Correction combobox selection in visual editor
  Help with updating
  Various bug fixes

2020-01-26 V1.5.0
   Add management of LUA libraries
   Add Import / Export of LUA files
   Add the possibility to put the data file
     in the following formats:
     - firefird
     - interbase
     - MariaDB
     - mysql
     - postgresql
     - sybase
  Supply of the driver MariaDB/Mysql 
  Various bug fixes

2020-01-19 V1.4.2
  Access by LUA code to the ConditionalFormatting property
  Add export of views
  Add APIs
    nsbase.filesystem.remove
    nsbase.filesystem.removeDirectories
    nsbase.filesystem.rename
    nsbase.filesystem.export
    nsbase.internet.httpPost
    nsbase.window.active.setFocus et self.setFocus
  Various bug fixes

2020-01-17 V1.4.1
  Add DBTreeView component in forms
  Add DBtreeView wizard
  Add ConditionalFormatting property in the datagrid
  Ergonomic and visual harmonization of wizards
  Export wizard improvement
  Add API
    nsbase.dialog.showExport
  Correction side effect editing tables
  Various bug fixes

2020-01-13 V1.4.0 (a,b,...)
  Add SSL support for internet APIs
  Add ColumnsWidth property to datagrid component
  Add datagrid creation wizard in the forms
  Display of default values ​​in insertion
   data in forms
  Add option save saved PDF  
  Display of default values ​​before insertion
  Add import protection of sqlite system tables
  Improved base cleaning in compaction
  Addition of positioning on the control in error,
    when updating SQL in forms
  Add buttons in LUA script editing mode
    Undo / Redo
    Fold / unfold
    Indent / deindent
  Add multilingual client application (see parameters)
  Delete file default.lng in standalone mode
  Add API
    nsbase.lang.getSys
    nsbase.lang.get
    nsbase.lang.set
    nsbase.lang.getList
    nsbase.lang.getAppList
    nsbase.lang.translate
    nsbase.internet.json.parse
    nsbase.internet.json.count
    nsbase.internet.json.value
  Add MarksStyle property in the Chart component
  Optimization of response time on saving objects, parameters
  Generalization of status and error display (status bar)
  Harmonization of the "Browse" buttons
  Correction of the "Browse" button of the selection of the data file (project parameters)
  Filter correction, and latent error "Stack overflow" of dbgrids
  Various bug fixes

2020-01-06 V1.3.6
  Add TimerInterval property to forms
  Add ActionOnTimer event to forms
  Add button name and label entry in button creation wizard
  API Help Enhancement
  Correction of button creation assistant: error referencing action
  Correction bug display help API nsbase.datasetCreate ("name") ....
  Correction of Hints positions in extended office
  Correction import under linux
  Various bug fixes

2020-01-04 V1.3.5
  Add FileName property to reports
  Add ActionOnOpn event to reports
  Review of the construction of stand-alone applications
  Various bug fixes

2020-01-03 V1.3.4
  Add container option in the fields tree when editing forms and reports
  Improved internationalization of NSBase
  Correction bug of not deleting children from a container when editing forms and reports
  Various bug fixes

2019-12-03 V1.3.3
  Add Tree Fields to Edit Forms and Reports
  Fixed bug (indroduced in V1.3.2) on the creation of the tables

2019-11-17 V1.3.2
  Add Reports Wizard
  Add Report Layout Dialog Box
  Improved security of the runtime module
  Improvement cleaning of the base
  Fixed default value of strings if multiple words
  Small improvements
  Integrates the corrections for linux V1.3.1a and V1.3.1b
  Various bug fixes

2019-06-03 V1.3.1
  Internationalization of language files (.lng)
  Add Greek language
  Add Croatian language
  Add Russian language
  Small improvements
  Various bug fixes

2019-05-27 V1.3.0
  Attention, internal redesign of access to the database!
   Full retranslation in different languages,
     taking into account accents and other specificities
   Add Dutch language
   Add Polish language 
   Add"Chart" component in forms
   Add Chart Component Creation Wizard
   Add component creation wizard "list"
   Revision of form creation wizard
   View version history, when changing version
   Addition in the contextual menu of the change of type of component
   Add component type display in type change menus
   Multi-language pass of the default value of the "Hints" property of the "Navigator" component
   Correction of type change of the ListBox component
   Fix datetimepicker component if the associated field is "null"
   Small improvements
   Fixed various bugs

2019-05-03 V1.2.3
  Add check box "Unique records" in the view editor
  The dataset.goto method has been renamed to dataset.gotorecord
  Add double click on DBGRids
  Significant acceleration of dataset.locate response time
  Sort datagrid field correction with spaces
  Corrected keypressed action
  Small improvements
  Various bug fixes

2019-04-25 V1.2.2
   Add Columns [0] .Title.Caption and Columumns [0] .Title.Alignment in Property Tree dbgrid
   Fix "not like" in the visual query editor
   Add the API nsbase.dialog.showDatasetFindReplace ('dbgrid')
   Add dataset.refresh () API
   Refreshing Warning message in search of datasets

2019-04-19 V1.2.1
   Addition of assistant buttons in LUA editor
   Correction Thread update of the list of functions (bug introduced with V1.2.0)
   Correction F10 visual failover / script in form editing, report
   Correction button "add page"
   Small improvements
   Fixed various bugs

2019-04-19 V1.2.0
  LUA editor
    Add "CodeFolder" (folding / unfolding)
    Add "IntelliSense" (Code Completion Help)
    Add MaskEdit and TextExit components in forms
    Component Replacement Edit by TextEdit (Automatic Migration)
    Add the following APIs:
      nsbase.application.width
      nsbase.application.clientWidth
      nsbase.application.height
      nsbase.application.clientHeight
      nsbase.application.top
      nsbase.application.left
      nsbase.application.windowState
      nbsase.application.centerForm ()
      Dataset.locate fix API
      Add "case", "nocase" , "anywhere" options  in the IP.locate dataset
      Add  DBGrid component columns in the tree of properties
      Add to Display of Components in Integration in forms and reports
      Update of the documentation
      Small improvements
      Various bug fixes

2019-04-11 V1.1.1
   Add "Create tables" and "import data" options in import module
   Add parameter "Open on startup the last used file"
   Reinforcement of LUA code control
   Add method "self.pageNew" to cause scripted page breaks in reports
   Add Portuguese language
   Update of the documentation
   Small improvements
   Fixed various bugs

2019-04-07 V1.1.0
   Add code search (form, report, views, scripts) throughout the active project
   Small improvements
   Fixed various bugs

2018-04-01 V1.0.9
   DateTimePicker component date and time transformation in string format
   Implementation of os.date (lua native) compatibility with NSBase components and apis
   Fixed inhibited buttons in multi editing
   Add option on the getOpened API (option)
   Add Api isOpen (windowName)
   Displaying Boolean Values in the Variable Explorer
   Update Invoices template
   Small improvements

2018-03-13 V1.0.8
   Online template Invoices
   Reworking documentation
   Uploading documentation
   Correction of various bugs

2018-03-13 V1.0.7
   Add toolbar to the data sheets
   Add creation from a template
   The datasource property accepts direct SQL queries
   The datasource property of datagrids is editable by LUA script
   Bug like correction in query editor
   Correction of various bugs

2018-03-10 V1.0.6
   Increased stability, especially under linux
   Improved ergonomics and speed of development (passage edition / opening and vice versa)
   Uploading .deb installation file for linux instead of .tar.gz
   Correction bug "recent files" (on 2 lines)
   Correction of various bugs

2018-03-02 V1.0.5
  WARNING nsbase.filesystem.readBinFile and .... writeBinFile APIs are replaced
    by nsbase.filesystem.readFile and nsbase.filesystem.writeFile with an option of
    format.
  Improved error handling in compiled mode and on stand-alone application
  Add dynamic display of global variables
  Add API nsbase.fileSystem.getDirectory
  Add format option on API nsbase.internet.httpGet
  Add items to the LUA editor
  Add OnActionErro, OnAfterPost and OnBeforePost events on the form / report
  Add action "Close all"
  Add closure of all tabs in standalone app build and compression project
    Name and name disassociation in object renaming
  Reshaping component vents
  Change user-agent on api nsnbase.internet.getHTTP
  Accelerated loading of the program, by
  Add the possibility of storing field values ??in the component database
    ListBox, ComboBox and RadiogRoup in digital or text format depending on the type of
    given in the database.
  Add RadioGroup component
  Add "text" property on Listbox
  Improvement control in table edition
  Improved opening of tables and reports
  Fixed opening two different objects with the same label
  Minor bug fixes

2018-02-21 V1.0.4
  Add Historical French versions
  Add the fold / unfold function of the main menu ribbon
  Add a history of recently used projects  Add OnLoaded and OnUnload action on form/report
  Add self reference in lua nsbase actions
  Changing NSbase procedural actions to NSBase object-type actions 
  Add copy / paste / cut functions in the design form
  Add multiple files for the database on the active project, 
    see the settings of the project page
  Add new hint style on application
  Add a property fit
  Add a property tag in the properties dialog
  Add muliple shortcut
  Continued enrichment of help (hints)
  Fixed Runmode bug on BorderIcon and Borderstyle
  Fixed a bug Drag in the treeview component on the form's parent
  Fixed a bug in getting the page number in the report
  Fixed minors bugs

2018-02-13 V1.0.3
  Add ControlDataSource property on dbnavigator component
  Add OnChange action DBGrid component
  Add dataset.locate APIs
  Update documentation APIs
  Fixed minors bugs

2018-02-12 V1.0.2
  Add Images and memo display on datagrid
  Add APIs
    nsbase.dialog
      nsbase.dialog.showMessage('type','msg')
      nsbase.dialog.input('title','prompt','Default')
      nsbase.dialog.fileOpen('title','filter','initialDir','filename')
      nsbase.dialog.fileSave('title','filter','initialDir','filename')
      nsbase.dialog.selectDirectory('title','initialDir')
    nsbase.fileSystem
      nsbase.fileSystem.fileToBase64('filename')
      nsbase.fileSystem.base64ToFile('string','filename')
      nsbase.fileSystem.directoryExists('directory')
      nsbase.fileSystem.fileExists('filename')
      nsbase.fileSystem.getSize('filename')
      nsbase.fileSystem.getLastModified('filename')
      nsbase.fileSystem.mkdir('directory')
      nsbase.fileSystem.copyFile('source','dest')
 
  Warnning : move APIs into dialog object
      nsbase.window.showMessage('type','msg')
      nsbase.window.input('title','prompt','Default')

  Implement APIs
     nsbase.internet.getValueAfter('Src','After')
     nsbase.internet.getValueBefore('Src','Before')
 
  implements property picture of image component for get and set, this format is base64
  Fixed minors bugs
  

2018-02-10 V1.0.1
  Add drag and drop control in component treeview on form editor for change parent
  Add delete keyboard on form/report editor
  Fixed the anarchic manipulation of the object selector in edits of forms and reports
  Fixed bugs 

2018-02-06 V1.0
  1st official version
  Redesign the Visual Query Editor	  

2018-01-06 Beta-0.4
  Significant acceleration of imports
  Add the csv format in file import
  Add properties and sub properties in most components
  Revision of table edition
  Fixed bugs

2018-01-05 Beta-0.3
  Fixed bugs

2018-01-02 Beta-0.2
  Improved build of standalone applications
  Add export 
  Add the Spanish language
  Fixed minors bugs

2017-12-18 Beta-0.1
  Finalization of the architecture, transition to Beta version
  Revision of the visual editor
  Restructuring of NSBase-specific APIs
  Add APIs
    nsbase.internet
      nsbase.internet.httpGet('url')
      nsbase.internet.URLEncode('url')
      nsbase.internet.URLDecode('url')
      nsbase.internet.HTMLToText('html')
      nsbase.internet.getValueAfter('Src','After')
      nsbase.internet.getValueBefore('Src','Before')
    nsbase.system
      nsbase.system.httpGet('url')
      nsbase.system.openUrl('url')
      nsbase.system.openDoc('doc')
      nsbase.system.getVersion()
      nsbase.system.getOS()
      nsbase.system.getCodeLang()
      nsbase.system.getClipboardText()
      nsbase.system.setClipboardText('text')
    dataset.SQL
    dataset.ExecSQL()
    dataset.open()
    dataset.close()
    dataset.getItems('fieldname')
  Fixed minors bugs

2017-12-18 Alpha-0.6
  Uploading the first windows 64 bits version
  Preselects the default local language
  Add Visual editor page in form parameters
  Change Control sizer
  Add contextuel menu in control sizer
  Fixed minors bugs
 
2017-12-16 Alpha-0.5 
  Add "vacuum" button
  Add "build standalone application" button
  Add "report bug" button 	
  Activing run form parameter
  Center forms in run mode
  Fixed bug action wizard "nsbse.application.quit()" => "nsbase.application.quit()"
  Fixed bug on post data. The error message is "Only one record should have been updated."

2017-12-14 Alpha-0.4 
  Uploading the first linux version
  Moving the quickbar to the right for harmonizing the display with linux
  Add the import of DBase files
  Fixed kexi database import
  Fixed the integration of the date, it caused a big slowdown on a "dd/mm/yyyy" date format
  Fixed minor bugs	

2017-12-13 Alpha-0.3 
  Add an automatic form creation wizard
  Add a dialog filter in the import function
  Add the "ChildSizing" property in the panels
  Add the "Parent Color" property in some form components
  Add the "ScrollBox" component in forms
  Review the display of the object creation form
  Fixed the list of fields in the view object
  Fixed minor bugs	

2017-12-11 Alpha-0.2
  Add additional languages: German and Italian
  Add database import function: text, MS Access, SQLite and Kexi  
  Restructuring of directories
  Fixed minor bugs

2017-12-08 Alpha-0.1
  Release of the original Alpha version on sourgeforge.net
